/* Copyright (C) 1998-1999 Kimmo.palin@helsinki.fi
   License: see COPYING
*/
#ifndef _CPU_ACCESS_H_
#define _CPU_ACCESS_H_
#include<gtk/gtk.h>

#include"cpu.h"

#define SET_PRIVLIGED(cpu) or_sr(cpu,STAT_P)
#define UNSET_PRIVLIGED(cpu) xor_sr(cpu,STAT_P)

extern GtkCList *GtkRegList;
extern GtkCList *GtkCPURegList;

int init_core(int size);

int setMem(cpudev *cpu, bit32 addr, memunit value);
memunit getMem(cpudev *cpu,bit32 addr);
bit32 or_sr(cpudev *cpu,bit32 value);
bit32 xor_sr(cpudev *cpu,bit32 value);
void set_pc(cpudev *cpu,bit32 value);
void set_sr(cpudev *cpu,bit32 value);
void set_ir(cpudev *cpu,opdata value);
void set_tr(cpudev *cpu,bit32 value);
void set_base(cpudev *cpu,bit32 value);
void set_limit(cpudev *cpu,bit32 value);
void set_mar(cpudev *cpu,bit32 value);
void set_reg(cpudev *cpu,bit32 value,unsigned int index);
void set_mbr(cpudev *cpu,memunit value);
bit32 get_mar(cpudev *cpu);
bit32 get_pc(cpudev *cpu);
bit32 get_sr(cpudev *cpu);
bit32 get_sr(cpudev *cpu);
bit32 get_tr(cpudev *cpu);
opdata get_ir(cpudev *cpu);
bit32 get_limit(cpudev *cpu);
bit32 get_base(cpudev *cpu);
bit32 get_reg(cpudev *cpu,unsigned int index);
memunit get_mbr(cpudev *cpu);
void print_core();

#endif 
